Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 4647)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 4648)
@@ -1215,10 +1142,9 @@
              DO  k = nzb, nzt
 !
-!--             In a first step, if grid point is below or equal the given 
-!--             terrain height, grid point is flagged to be of type natural. 
-!--             Please note, in case there is also a building which is lower
-!--             than the vertical grid spacing, initialization of surface
-!--             attributes will not be correct as given surface information
-!--             will not be in accordance to the classified grid points. 
+!--             In a first step, if grid point is below or equal the given terrain height, grid
+!--             point is flagged to be of type natural.
+!--             Please note, in case there is also a building which is lower than the vertical grid
+!--             spacing, initialization of surface attributes will not be correct as given surface
+!--             information will not be in accordance to the classified grid points.
 !--             Hence, in this case, also a building flag.
                 IF ( zu(k) - ocean_offset <= terrain_height_f%var(j,i) )  THEN
@@ -1228,18 +1154,17 @@
                 ENDIF
 !
-!--             Set building grid points. Here, only consider 2D buildings. 
-!--             3D buildings require separate treatment. 
+!--             Set building grid points. Here, only consider 2D buildings.
+!--             3D buildings require separate treatment.
                 IF ( buildings_f%from_file  .AND.  buildings_f%lod == 1 )  THEN
 !
-!--                Fill-up the terrain to the level of maximum orography
-!--                within the building-covered area.
+!--                Fill-up the terrain to the level of maximum orography within the building-covered
+!--                area.
                    IF ( building_id_f%var(j,i) /= building_id_f%fill )  THEN
 !
-!--                   Note, oro_max is always on zw level                   
+!--                   Note, oro_max is always on zw level
                       IF ( zu(k) - ocean_offset < oro_max(nr) )  THEN
                          topo_3d(k,j,i) = IBCLR( topo_3d(k,j,i), 0 )
                          topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 1 )
-                      ELSEIF ( zu(k) - ocean_offset <=                         &
-                               oro_max(nr) + buildings_f%var_2d(j,i) )  THEN
+                      ELSEIF ( zu(k) - ocean_offset <= oro_max(nr) + buildings_f%var_2d(j,i) )  THEN
                          topo_3d(k,j,i) = IBCLR( topo_3d(k,j,i), 0 )
                          topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 2 )
@@ -1249,12 +1174,10 @@
              ENDDO
 !
-!--          Special treatment for non grid-resolved buildings. This case,
-!--          the uppermost terrain grid point is flagged as building as well
-!--          well, even though no building exists at all. However, the 
-!--          surface element will be identified as urban-surface and the 
-!--          input data provided by the drivers is consistent to the surface
-!--          classification. Else, all non grid-resolved buildings would vanish
-!--          and identified as terrain grid points, which, however, won't be
-!--          consistent with the input data. 
+!--          Special treatment for non grid-resolved buildings. This case, the uppermost terrain
+!--          grid point is flagged as building as well, even though no building exists at all.
+!--          However, the surface element will be identified as urban-surface and the input data
+!--          provided by the drivers is consistent to the surface classification. Else, all non
+!--          grid-resolved buildings would vanish and identified as terrain grid points, which,
+!--          however, won't be consistent with the input data.
              IF ( buildings_f%from_file  .AND.  buildings_f%lod == 1 )  THEN
                 IF ( building_id_f%var(j,i) /= building_id_f%fill )  THEN
@@ -1269,35 +1192,32 @@
              ENDIF
 !
-!--          Map 3D buildings onto terrain height.  
-!--          In case of any slopes, map building on top of maximum terrain 
-!--          height covered by the building. In other words, extend 
-!--          building down to the respective local terrain-surface height. 
+!--          Map 3D buildings onto terrain height.
+!--          In case of any slopes, map building on top of maximum terrain height covered by the
+!--          building. In other words, extend building down to the respective local terrain-surface
+!--          height.
              IF ( buildings_f%from_file  .AND.  buildings_f%lod == 2 )  THEN
                 IF ( building_id_f%var(j,i) /= building_id_f%fill )  THEN
 !
-!--                Extend building down to the terrain surface, i.e. fill-up
-!--                surface irregularities below a building. Note, oro_max
-!--                is already a discrete height according to the all-or-nothing
-!--                approach, i.e. grid box is either topography or atmosphere, 
+!--                Extend building down to the terrain surface, i.e. fill-up surface irregularities
+!--                below a building. Note, oro_max is already a discrete height according to the
+!--                all-or-nothing approach, i.e. grid box is either topography or atmosphere,
 !--                terrain top is defined at upper bound of the grid box.
-!--                Hence, check for zw in this case. 
-!--                Note, do this only for buildings which are surface mounted, 
-!--                i.e. building types 1-6. Below bridges, which are represented
-!--                exclusively by building type 7, terrain shape should be
-!--                maintained. 
+!--                Hence, check for zw in this case.
+!--                Note, do this only for buildings which are surface mounted, i.e. building types
+!--                1-6. Below bridges, which are represented exclusively by building type 7, terrain
+!--                shape should be maintained.
                    IF ( building_type_f%from_file )  THEN
                       IF ( building_type_f%var(j,i) /= 7 )  THEN
-                         DO k = topo_top_index + 1, nzt + 1      
+                         DO k = topo_top_index + 1, nzt + 1
                             IF ( zu(k) - ocean_offset <= oro_max(nr) )  THEN
                                topo_3d(k,j,i) = IBCLR( topo_3d(k,j,i), 0 )
                                topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 1 )
                             ENDIF
-                         ENDDO        
-!                     
-!--                      After surface irregularities are smoothen, determine 
-!--                      lower start index where building starts. 
+                         ENDDO
+!
+!--                      After surface irregularities are smoothen, determine lower start index
+!--                      where building starts.
                          DO  k = nzb, nzt
-                            IF ( zu(k) - ocean_offset <= oro_max(nr) )         &
-                               topo_top_index = k
+                            IF ( zu(k) - ocean_offset <= oro_max(nr) )  topo_top_index = k
                          ENDDO
                       ENDIF
@@ -1320,6 +1240,6 @@
        ENDDO
 !
-!--    Horizontal exchange the oro_max array, which is required to for
-!--    initialization of building-surface properties.
+!--    Horizontal exchange the oro_max array, which is required to for initialization of
+!--    building-surface properties.
        IF ( ALLOCATED( buildings_f%oro_max ) )  THEN
           CALL exchange_horiz_2d( buildings_f%oro_max(:,:) )
@@ -1331,14 +1251,13 @@
        IF ( ALLOCATED( build_ids_final ) )  DEALLOCATE( build_ids_final )
 !
-!-- Topography input via ASCII format. 
+!-- Topography input via ASCII format.
     ELSE
        ocean_offset     = MERGE( zw(0), 0.0_wp, ocean_mode )
 !
-!--    Initialize topography bit 0 (indicates obstacle) everywhere to zero
-!--    and clear all grid points at nzb, where alway a surface is defined.
-!--    Further, set also bit 1 (indicates terrain) at nzb, which is further
-!--    used for masked data output and further processing. Note, in the 
-!--    ASCII case no distinction is made between buildings and terrain, 
-!--    so that setting of bit 1 and 2 at the same time has no effect. 
+!--    Initialize topography bit 0 (indicates obstacle) everywhere to zero and clear all grid points
+!--    at nzb, where alway a surface is defined.
+!--    Further, set also bit 1 (indicates terrain) at nzb, which is further used for masked data
+!--    output and further processing. Note, in the ASCII case no distinction is made between
+!--    buildings and terrain,  so that setting of bit 1 and 2 at the same time has no effect.
        topo_3d          = IBSET( topo_3d, 0 )
        topo_3d(nzb,:,:) = IBCLR( topo_3d(nzb,:,:), 0 )
@@ -1348,9 +1267,7 @@
              DO  k = nzb, nzt
 !
-!--             Flag topography for all grid points which are below
-!--             the local topography height. 
-!--             Note, each topography is flagged as building (bit 2) as well as 
-!--             terrain (bit 1) in order to employ urban-surface as well as 
-!--             land-surface model.
+!--             Flag topography for all grid points which are below the local topography height.
+!--             Note, each topography is flagged as building (bit 2) as well as terrain (bit 1) in
+!--             order to employ urban-surface as well as land-surface model.
                 IF ( zu(k) - ocean_offset <= buildings_f%var_2d(j,i) )  THEN
                    topo_3d(k,j,i) = IBCLR( topo_3d(k,j,i), 0 )
@@ -1372,5 +1289,5 @@
     IF ( .NOT. bc_lr_cyc )  THEN
        IF ( nxl == 0  )  topo_3d(:,:,-1)   = topo_3d(:,:,0)
-       IF ( nxr == nx )  topo_3d(:,:,nx+1) = topo_3d(:,:,nx)          
+       IF ( nxr == nx )  topo_3d(:,:,nx+1) = topo_3d(:,:,nx)
     ENDIF
 
@@ -1379,42 +1296,44 @@
 
 ! Description:
-! -----------------------------------------------------------------------------!
-!> Filter topography, i.e. fill holes resolved by only one grid point.  
-!> Such holes are suspected to lead to velocity blow-ups as continuity 
-!> equation on discrete grid cannot be fulfilled in such case.
-!------------------------------------------------------------------------------!
+! -------------------------------------------------------------------------------------------------!
+!> Filter topography, i.e. fill holes resolved by only one grid point.
+!> Such holes are suspected to lead to velocity blow-ups as continuity equation on discrete grid
+!> cannot be fulfilled in such case.
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE filter_topography( topo_3d )
 
-    USE control_parameters,                                                    &
+    USE control_parameters,                                                                        &
         ONLY:  bc_lr_cyc, bc_ns_cyc, message_string
 
-    USE exchange_horiz_mod,                                                    &
+    USE exchange_horiz_mod,                                                                        &
         ONLY:  exchange_horiz_int, exchange_horiz_2d_byte, exchange_horiz_2d_int
 
-    USE indices,                                                               &
+    USE indices,                                                                                   &
         ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nzb, nzt
 
-    USE netcdf_data_input_mod,                                                 &
-        ONLY:  building_id_f, building_type_f 
+    USE netcdf_data_input_mod,                                                                     &
+        ONLY:  building_id_f, building_type_f
 
     USE  pegrid
 
     IMPLICIT NONE
-
-    LOGICAL      ::  filled = .FALSE. !< flag indicating if holes were filled
 
     INTEGER(iwp) ::  i          !< running index along x-direction
     INTEGER(iwp) ::  j          !< running index along y-direction
     INTEGER(iwp) ::  k          !< running index along z-direction
-    INTEGER(iwp) ::  num_hole   !< number of holes (in topography) resolved by only one grid point 
-    INTEGER(iwp) ::  num_hole_l !< number of holes (in topography) resolved by only one grid point on local PE     
+    INTEGER(iwp) ::  num_hole   !< number of holes (in topography) resolved by only one grid point
+    INTEGER(iwp) ::  num_hole_l !< number of holes (in topography) resolved by only one grid point on local PE
     INTEGER(iwp) ::  num_wall   !< number of surrounding vertical walls for a single grid point
 
     INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE            ::  topo_tmp          !< temporary 3D-topography used to fill holes
-    INTEGER(iwp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  topo_3d           !< 3D-topography array merging buildings and orography
-!
-!-- Before checking for holes, set lateral boundary conditions for 
+    INTEGER(iwp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  topo_3d           !< 3D-topography array merging buildings and
+                                                                                 !< orography
+
+    LOGICAL      ::  filled = .FALSE. !< flag indicating if holes were filled
+
+!
+!-- Before checking for holes, set lateral boundary conditions for
 !-- topography. After hole-filling, boundary conditions must be set again.
-!-- Several iterations are performed, in order to fill holes which might 
+!-- Several iterations are performed, in order to fill holes which might
 !-- emerge by the filling-algorithm itself.
     ALLOCATE( topo_tmp(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
@@ -1422,21 +1341,20 @@
 
     num_hole = 99999
-    DO WHILE ( num_hole > 0 )       
-
-       num_hole = 0    
+    DO WHILE ( num_hole > 0 )
+
+       num_hole = 0
        CALL exchange_horiz_int( topo_3d, nys, nyn, nxl, nxr, nzt, nbgp )
 !
-!--    Exchange also building ID and type. Note, building_type is an one-byte 
-!--    variable.
-       IF ( building_id_f%from_file )                                          &
+!--    Exchange also building ID and type. Note, building_type is an one-byte variable.
+       IF ( building_id_f%from_file )                                                              &
           CALL exchange_horiz_2d_int( building_id_f%var, nys, nyn, nxl, nxr, nbgp )
-       IF ( building_type_f%from_file )                                        &
+       IF ( building_type_f%from_file )                                                            &
           CALL exchange_horiz_2d_byte( building_type_f%var, nys, nyn, nxl, nxr, nbgp )
 
        topo_tmp = topo_3d
 !
-!--    In case of non-cyclic lateral boundaries, assume lateral boundary to be 
-!--    a solid wall. Thus, intermediate spaces of one grid point between 
-!--    boundary and some topographic structure will be filled.           
+!--    In case of non-cyclic lateral boundaries, assume lateral boundary to be a solid wall. Thus,
+!--    intermediate spaces of one grid point between boundary and some topographic structure will be
+!--    filled.
        IF ( .NOT. bc_ns_cyc )  THEN
           IF ( nys == 0  )  topo_tmp(:,-1,:)   = IBCLR( topo_tmp(:,0,:),  0 )
@@ -1446,5 +1364,5 @@
        IF ( .NOT. bc_lr_cyc )  THEN
           IF ( nxl == 0  )  topo_tmp(:,:,-1)   = IBCLR( topo_tmp(:,:,0),  0 )
-          IF ( nxr == nx )  topo_tmp(:,:,nx+1) = IBCLR( topo_tmp(:,:,nx), 0 )          
+          IF ( nxr == nx )  topo_tmp(:,:,nx+1) = IBCLR( topo_tmp(:,:,nx), 0 )
        ENDIF
 
@@ -1455,73 +1373,48 @@
                 IF ( BTEST( topo_tmp(k,j,i), 0 ) )  THEN
                    num_wall = 0
-                   IF ( .NOT. BTEST( topo_tmp(k,j-1,i), 0 ) )                  &
-                      num_wall = num_wall + 1
-                   IF ( .NOT. BTEST( topo_tmp(k,j+1,i), 0 ) )                  &
-                      num_wall = num_wall + 1
-                   IF ( .NOT. BTEST( topo_tmp(k,j,i-1), 0 ) )                  &
-                      num_wall = num_wall + 1
-                   IF ( .NOT. BTEST( topo_tmp(k,j,i+1), 0 ) )                  &
-                      num_wall = num_wall + 1
-                   IF ( .NOT. BTEST( topo_tmp(k-1,j,i), 0 ) )                  &
-                      num_wall = num_wall + 1   
-                   IF ( .NOT. BTEST( topo_tmp(k+1,j,i), 0 ) )                  &
-                      num_wall = num_wall + 1
+                   IF ( .NOT. BTEST( topo_tmp(k,j-1,i), 0 ) )  num_wall = num_wall + 1
+                   IF ( .NOT. BTEST( topo_tmp(k,j+1,i), 0 ) )  num_wall = num_wall + 1
+                   IF ( .NOT. BTEST( topo_tmp(k,j,i-1), 0 ) )  num_wall = num_wall + 1
+                   IF ( .NOT. BTEST( topo_tmp(k,j,i+1), 0 ) )  num_wall = num_wall + 1
+                   IF ( .NOT. BTEST( topo_tmp(k-1,j,i), 0 ) )  num_wall = num_wall + 1
+                   IF ( .NOT. BTEST( topo_tmp(k+1,j,i), 0 ) )  num_wall = num_wall + 1
 
                    IF ( num_wall >= 4 )  THEN
                       num_hole_l     = num_hole_l + 1
 !
-!--                   Clear flag 0 and set special flag ( bit 4) to indicate 
-!--                   that new topography point is a result of filtering process.
+!--                   Clear flag 0 and set special flag ( bit 4) to indicate that new topography
+!--                   point is a result of filtering process.
                       topo_3d(k,j,i) = IBCLR( topo_3d(k,j,i), 0 )
                       topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 4 )
 !
-!--                   If filled grid point is occupied by a building, classify
-!--                   it as building grid point.
+!--                   If filled grid point is occupied by a building, classify it as building grid
+!--                   point.
                       IF ( building_type_f%from_file )  THEN
-                         IF ( building_type_f%var(j,i)   /=                    &  
-                              building_type_f%fill            .OR.             &       
-                              building_type_f%var(j+1,i) /=                    &  
-                              building_type_f%fill            .OR.             &                
-                              building_type_f%var(j-1,i) /=                    &                
-                              building_type_f%fill            .OR.             &                
-                              building_type_f%var(j,i+1) /=                    &                
-                              building_type_f%fill            .OR.             &                
-                              building_type_f%var(j,i-1) /=                    &                
-                              building_type_f%fill )  THEN
+                         IF ( building_type_f%var(j,i)   /=  building_type_f%fill  .OR.            &
+                              building_type_f%var(j+1,i) /=  building_type_f%fill  .OR.            &
+                              building_type_f%var(j-1,i) /=  building_type_f%fill  .OR.            &
+                              building_type_f%var(j,i+1) /=  building_type_f%fill  .OR.            &
+                              building_type_f%var(j,i-1) /=  building_type_f%fill )  THEN
 !
 !--                         Set flag indicating building surfaces
                             topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 2 )
 !
-!--                         Set building_type and ID at this position if not 
-!--                         already set. This is required for proper 
-!--                         initialization of urban-surface energy balance 
+!--                         Set building_type and ID at this position if not already set. This is
+!--                         required for proper initialization of urban-surface energy balance
 !--                         solver.
-                            IF ( building_type_f%var(j,i) ==                   &
-                                 building_type_f%fill )  THEN
-
-                               IF ( building_type_f%var(j+1,i) /=              &
-                                    building_type_f%fill )  THEN
-                                  building_type_f%var(j,i) =                   &
-                                                    building_type_f%var(j+1,i)
-                                  building_id_f%var(j,i) =                     &
-                                                    building_id_f%var(j+1,i)
-                               ELSEIF ( building_type_f%var(j-1,i) /=          &
-                                        building_type_f%fill )  THEN
-                                  building_type_f%var(j,i) =                   &
-                                                    building_type_f%var(j-1,i)
-                                  building_id_f%var(j,i) =                     &
-                                                    building_id_f%var(j-1,i)
-                               ELSEIF ( building_type_f%var(j,i+1) /=          &
-                                        building_type_f%fill )  THEN
-                                  building_type_f%var(j,i) =                   &
-                                                    building_type_f%var(j,i+1)
-                                  building_id_f%var(j,i) =                     &
-                                                    building_id_f%var(j,i+1)
-                               ELSEIF ( building_type_f%var(j,i-1) /=          &
-                                        building_type_f%fill )  THEN
-                                  building_type_f%var(j,i) =                   &
-                                                    building_type_f%var(j,i-1)
-                                  building_id_f%var(j,i) =                     &
-                                                    building_id_f%var(j,i-1)
+                            IF ( building_type_f%var(j,i) == building_type_f%fill )  THEN
+
+                               IF ( building_type_f%var(j+1,i) /= building_type_f%fill )  THEN
+                                  building_type_f%var(j,i) = building_type_f%var(j+1,i)
+                                  building_id_f%var(j,i)   = building_id_f%var(j+1,i)
+                               ELSEIF ( building_type_f%var(j-1,i) /= building_type_f%fill )  THEN
+                                  building_type_f%var(j,i) = building_type_f%var(j-1,i)
+                                  building_id_f%var(j,i)   = building_id_f%var(j-1,i)
+                               ELSEIF ( building_type_f%var(j,i+1) /= building_type_f%fill )  THEN
+                                  building_type_f%var(j,i) = building_type_f%var(j,i+1)
+                                  building_id_f%var(j,i)   = building_id_f%var(j,i+1)
+                               ELSEIF ( building_type_f%var(j,i-1) /= building_type_f%fill )  THEN
+                                  building_type_f%var(j,i) = building_type_f%var(j,i-1)
+                                  building_id_f%var(j,i)   = building_id_f%var(j,i-1)
                                ENDIF
                             ENDIF
@@ -1529,8 +1422,7 @@
                       ENDIF
 !
-!--                   If filled grid point is already classified as building
-!--                   everything is fine, else classify this grid point as
-!--                   natural type grid point. This case, values for the 
-!--                   surface type are already set.
+!--                   If filled grid point is already classified as building everything is fine,
+!--                   else classify this grid point as natural type grid point. This case, values
+!--                   for the surface type are already set.
                       IF ( .NOT. BTEST( topo_3d(k,j,i), 2 ) )  THEN
                          topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 1 )
@@ -1544,9 +1436,8 @@
 !--    Count the total number of holes, required for informative message.
 #if defined( __parallel )
-       CALL MPI_ALLREDUCE( num_hole_l, num_hole, 1, MPI_INTEGER, MPI_SUM,      &
-                           comm2d, ierr )
+       CALL MPI_ALLREDUCE( num_hole_l, num_hole, 1, MPI_INTEGER, MPI_SUM, comm2d, ierr )
 #else
        num_hole = num_hole_l
-#endif    
+#endif
        IF ( num_hole > 0  .AND.  .NOT. filled )  filled = .TRUE.
 
@@ -1555,6 +1446,6 @@
 !-- Create an informative message if any holes were filled.
     IF ( filled )  THEN
-       WRITE( message_string, * ) 'Topography was filtered, i.e. holes ' //    &
-                                  'resolved by only one grid point '     //    &
+       WRITE( message_string, * ) 'Topography was filtered, i.e. holes ' //                        &
+                                  'resolved by only one grid point '     //                        &
                                   'were filled during initialization.'
        CALL message( 'init_grid', 'PA0430', 0, 0, 0, 6, 0 )
@@ -1563,6 +1454,6 @@
     DEALLOCATE( topo_tmp )
 !
-!-- Finally, exchange topo_3d array again and if necessary set Neumann boundary
-!-- condition in case of non-cyclic lateral boundaries. 
+!-- Finally, exchange topo_3d array again and if necessary set Neumann boundary condition in case of
+!-- non-cyclic lateral boundaries.
     CALL exchange_horiz_int( topo_3d, nys, nyn, nxl, nxr, nzt, nbgp )
 
@@ -1574,11 +1465,11 @@
     IF ( .NOT. bc_lr_cyc )  THEN
        IF ( nxl == 0  )  topo_3d(:,:,-1)   = topo_3d(:,:,0)
-       IF ( nxr == nx )  topo_3d(:,:,nx+1) = topo_3d(:,:,nx)          
+       IF ( nxr == nx )  topo_3d(:,:,nx+1) = topo_3d(:,:,nx)
     ENDIF
 !
 !-- Exchange building ID and type. Note, building_type is an one-byte variable.
-    IF ( building_id_f%from_file )                                             &
+    IF ( building_id_f%from_file )                                                                 &
        CALL exchange_horiz_2d_int( building_id_f%var, nys, nyn, nxl, nxr, nbgp )
-    IF ( building_type_f%from_file )                                           &
+    IF ( building_type_f%from_file )                                                               &
        CALL exchange_horiz_2d_byte( building_type_f%var, nys, nyn, nxl, nxr, nbgp )
 
@@ -1587,37 +1478,33 @@
 
 ! Description:
-! -----------------------------------------------------------------------------!
-!> Reads topography information from file or sets generic topography. Moreover, 
-!> all topography-relevant topography arrays are initialized, and grid flags
-!> are set.  
-!------------------------------------------------------------------------------!
+! -------------------------------------------------------------------------------------------------!
+!> Reads topography information from file or sets generic topography. Moreover, all
+!> topography-relevant topography arrays are initialized, and grid flags are set.
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE init_topo( topo )
 
-    USE arrays_3d,                                                             &
+    USE arrays_3d,                                                                                 &
         ONLY:  zw
-        
-    USE control_parameters,                                                    &
-        ONLY:  bc_lr_cyc, bc_ns_cyc, building_height, building_length_x,       &
-               building_length_y, building_wall_left, building_wall_south,     &
-               canyon_height, canyon_wall_left, canyon_wall_south,             &
-               canyon_width_x, canyon_width_y, dp_level_ind_b, dz,             &
-               message_string, topography, topography_grid_convention,         &
-               tunnel_height, tunnel_length, tunnel_width_x, tunnel_width_y,   &
-               tunnel_wall_depth
-         
-    USE exchange_horiz_mod,                                                    &
+
+    USE control_parameters,                                                                        &
+        ONLY:  bc_lr_cyc, bc_ns_cyc, building_height, building_length_x, building_length_y,        &
+               building_wall_left, building_wall_south, canyon_height, canyon_wall_left,           &
+               canyon_wall_south, canyon_width_x, canyon_width_y, dp_level_ind_b, dz,              &
+               message_string, topography, topography_grid_convention, tunnel_height,              &
+               tunnel_length, tunnel_width_x, tunnel_width_y, tunnel_wall_depth
+
+    USE exchange_horiz_mod,                                                                        &
         ONLY:  exchange_horiz_int
 
-    USE grid_variables,                                                        &
+    USE grid_variables,                                                                            &
         ONLY:  dx, dy
-        
-    USE indices,                                                               &
-        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nz,   &
-               nzb, nzt
-    
+
+    USE indices,                                                                                   &
+        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nz, nzb, nzt
+
     USE kinds
-    
-    USE netcdf_data_input_mod,                                                 &
-        ONLY:  buildings_f, terrain_height_f 
+
+    USE netcdf_data_input_mod,                                                                     &
+        ONLY:  buildings_f, terrain_height_f
 
     USE pegrid
